# gitlab runner

command used to register new runner

```shell script
$ docker run -d --name gitlab-runner --restart always -v /var/run/docker.sock:/var/run/docker.sock -v gitlab-runner-config:/etc/gitlab-runner gitlab/gitlab-runner:latest

$ gitlab-runner register -non-interactive --description "manualy registered gitlab runner" --url "http://172.17.0.1:8080/" --registration-token "3b79eb1f-32f3-4db2-ad1b-6
  702e476d839" --tag-list "docker,manual" --executor shell
```

same with curl

```shell script
$ curl --request POST -H 'Content-Type: application/json' "http://localhost:8080/api/v4/runners" -d '{"description":"manualy registered gitlab runner","tag_list":"docker,manual","run_untagged":false,"locked":true,"active":true,"info":{"name":"gitlab-runner","version":"13.3.1","revision":"738bbe5a","platform":"linux","architecture":"amd64","features":{"variables":false,"image":false,"services":false,"artifacts":false,"cache":false,"shared":false,"upload_multiple_artifacts":false,"upload_raw_artifacts":false,"session":false,"terminal":false,"refspecs":false,"masking":false,"proxy":false,"raw_variables":false,"artifacts_exclude":false,"multi_build_steps":false}},"token":"registration_token"}'
```



---

```json
{
  "description":"manualy registered gitlab runner",
  "tag_list":"docker,manual",
  "run_untagged":false,
  "locked":true,
  "active":true,
  "info":{
    "name":"gitlab-runner",
    "version":"13.3.1",
    "revision":"738bbe5a",
    "platform":"linux",
    "architecture":"amd64",
    "features":{
      "variables":false,
      "image":false,
      "services":false,
      "artifacts":false,
      "cache":false,
      "shared":false,
      "upload_multiple_artifacts":false,
      "upload_raw_artifacts":false,
      "session":false,
      "terminal":false,
      "refspecs":false,
      "masking":false,
      "proxy":false,
      "raw_variables":false,
      "artifacts_exclude":false,
      "multi_build_steps":false
    }
  },
  "token":"registration_token"
}
```

## http call use when job is run

```
[POST /api/v4/jobs/request HTTP/1.1
Host: 172.17.0.1:8080
User-Agent: gitlab-runner 13.3.1 (13-3-stable; go1.13.8; linux/amd64)
Content-Length: 510
Accept: application/json
Content-Type: application/json
Accept-Encoding: gzip
```

```json
{
   "info":{
      "name":"gitlab-runner",
      "version":"13.3.1",
      "revision":"738bbe5a",
      "platform":"linux",
      "architecture":"amd64",
      "executor":"shell",
      "shell":"bash",
      "features":{
         "variables":true,
         "image":false,
         "services":false,
         "artifacts":true,
         "cache":true,
         "shared":true,
         "upload_multiple_artifacts":true,
         "upload_raw_artifacts":true,
         "session":true,
         "terminal":true,
         "refspecs":true,
         "masking":true,
         "proxy":false,
         "raw_variables":true,
         "artifacts_exclude":true,
         "multi_build_steps":true
      }
   },
   "token":"76a79b73-b211-48c6-a3da-6b99fb8b0612"
}
```

...
